searchNodes=[{"ref":"ExDoubles.html","title":"ExDoubles","type":"module","doc":""},{"ref":"ExDoubles.html#called_with/1","title":"ExDoubles.called_with/1","type":"function","doc":""},{"ref":"ExDoubles.html#mock/3","title":"ExDoubles.mock/3","type":"function","doc":""},{"ref":"ExDoubles.html#once/0","title":"ExDoubles.once/0","type":"function","doc":""},{"ref":"ExDoubles.html#thrice/0","title":"ExDoubles.thrice/0","type":"function","doc":""},{"ref":"ExDoubles.html#times/1","title":"ExDoubles.times/1","type":"function","doc":""},{"ref":"ExDoubles.html#twice/0","title":"ExDoubles.twice/0","type":"function","doc":""},{"ref":"ExDoubles.html#verify/2","title":"ExDoubles.verify/2","type":"function","doc":""},{"ref":"ExDoubles.html#t:argument_matcher/0","title":"ExDoubles.argument_matcher/0","type":"type","doc":""},{"ref":"ExDoubles.html#t:call_count_matcher/0","title":"ExDoubles.call_count_matcher/0","type":"type","doc":""},{"ref":"ExDoubles.ErrorMessages.html","title":"ExDoubles.ErrorMessages","type":"module","doc":""},{"ref":"ExDoubles.ErrorMessages.html#arity_not_supported/0","title":"ExDoubles.ErrorMessages.arity_not_supported/0","type":"function","doc":""},{"ref":"ExDoubles.ErrorMessages.html#call_count_incorrect/2","title":"ExDoubles.ErrorMessages.call_count_incorrect/2","type":"function","doc":""},{"ref":"ExDoubles.ErrorMessages.html#not_called_error/3","title":"ExDoubles.ErrorMessages.not_called_error/3","type":"function","doc":""},{"ref":"ExDoubles.ErrorMessages.html#unsupported_call/0","title":"ExDoubles.ErrorMessages.unsupported_call/0","type":"function","doc":""},{"ref":"ExDoubles.ListenerFactory.html","title":"ExDoubles.ListenerFactory","type":"module","doc":""},{"ref":"ExDoubles.ListenerFactory.html#make_listener/2","title":"ExDoubles.ListenerFactory.make_listener/2","type":"function","doc":""},{"ref":"ExDoubles.State.html","title":"ExDoubles.State","type":"module","doc":""},{"ref":"ExDoubles.State.html#add_mock/1","title":"ExDoubles.State.add_mock/1","type":"function","doc":""},{"ref":"ExDoubles.State.html#call_count/1","title":"ExDoubles.State.call_count/1","type":"function","doc":""},{"ref":"ExDoubles.State.html#child_spec/1","title":"ExDoubles.State.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExDoubles.State.html#get_mock/1","title":"ExDoubles.State.get_mock/1","type":"function","doc":""},{"ref":"ExDoubles.State.html#increment/2","title":"ExDoubles.State.increment/2","type":"function","doc":""},{"ref":"ExDoubles.State.html#init/1","title":"ExDoubles.State.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"ExDoubles.State.html#start_link/0","title":"ExDoubles.State.start_link/0","type":"function","doc":""},{"ref":"ExDoubles.State.html#stop/0","title":"ExDoubles.State.stop/0","type":"function","doc":""},{"ref":"readme.html","title":"ExDoubles","type":"extras","doc":"ExDoubles ExDoubles is an opinionated mocking library for Elixir. It takes the stance that the easiest way to create loose coupling in your codebase is to follow the Dependency Inversion Principle (DIP) described below."},{"ref":"readme.html#why-another-mock-framework","title":"ExDoubles - Why another mock framework?","type":"extras","doc":"There are already a few other mock libraries for Elixir. However they either allow you to mock code you don&#39;t own, or provide Erlang like syntax. Mocking and testing in general are activities that give you feedback on the design of your code. If you mock functions that you don&#39;t own, you are learning about how difficult they are to test, but you can&#39;t respond to the pain. You are stuck with the design decisions of the framework authors. ExDoubles wants you to wrap the code you don&#39;t own in a simple well defined interface, a function. Then you can then mock that function and be on your way. We also want Elixir to be popular. In order for that to happen, there needs to be a cohesive ecosystem. Tools should feel consistent and easy to learn. No Erlang knowledge should be required!"},{"ref":"readme.html#how-does-it-work","title":"ExDoubles - How does it work?","type":"extras","doc":"As consequence of applying the DIP, we can unit test a function by injecting in a mock functions as arguments. This is where ExDoubles shines! You can construct a mock for the signature of any function, using the mock macro. It takes a label for your function, and the arity. The arity argument makes sure your mock has the same number of arguments. Whereas the label is used by the verify macro to check that your function was invoked in the correct way. Let&#39;s build an example. First, we create a mock for the save_fn argument of a function we ware testing. We specify a label and the arity we want it to have. {:ok, mock_save_fn} = mock(:save_fn_label, 2) Next we can pass the mock_save_fn into our function under test, calculate_employee_pay. calculate_employee_pay([], &quot;some_employee_id&quot;, mock_save_fn) Lastly we verify that our function was invoked with the correct data. assert verify(:save_fn_label, called_with([&quot;some_employee_id&quot;, 0])) A complete example test is: test &quot;employee with no hours receives zero pay&quot; do {:ok, mock_save_fn} = mock(:save_fn_label, 2) calculate_employee_pay([], &quot;some_employee_id&quot;, mock_save_fn) assert verify(:save_fn_label, called_with([&quot;some_employee_id&quot;, 0])) end"},{"ref":"readme.html#stubbing","title":"ExDoubles - Stubbing","type":"extras","doc":"ExDoubles can also allow you to return values from your mocks, this is called stubbing. test &quot;returns stubbed value&quot; do {:ok, no_arg_moc} = mock(:no_arg_label, 0, &quot;stubbed_value&quot;) assert &quot;stubbed_value&quot; == no_arg_moc() end"},{"ref":"readme.html#matchers","title":"ExDoubles - Matchers","type":"extras","doc":"Currently ExDoubles has a few Call Count matchers and one Argument matcher. Call Count matchers Call Count matchers do pretty much what you would expect. They are: assert verify(:mock_fn, once()) assert verify(:mock_fn, twice()) assert verify(:mock_fn, thrice()) assert verify(:mock_fn, times(10)) Argument matcher The only argument matcher at this time is called_with this function takes a label for a mock and the arguments it is expected to have received. It returns truthy or falsey which should be used with the ExUnit.Case assert function. assert verify(:mock_label, called_with([[], &quot;some_user_id&quot;]))"},{"ref":"readme.html#dependency-inversion-principle","title":"ExDoubles - Dependency Inversion Principle","type":"extras","doc":"The Dependency Inversion Principle tells us that high level functions should not depend on low level ones, and both should depend on abstractions. An example is an application that calculates payroll. In this example there is code that takes a list of hours for an employee id, and then saves that pay cycle value to the database. defmodule PayCycle do def calculate_employee_pay(hours, employee_id) do # ... complex calculation logic omitted Db.PayRoll.save_payroll_to_database(employee_id, pay) end end defmodule Db.PayRoll do def save_payroll_to_database(employee_id, pay) do %PayRoll{ employee_id: employee_id, pay: calculated_value } |&gt; PayRoll.changeset() |&gt; Db.Repo end end In this example you will notice that the Db.PayRoll.save_payroll_to_database function is directly invoked by the high level module of calculating the pay for an employee. The Dependency Inversion Principle (DIP) recommends that the PayCycle module not depend directly on the Db.PayRoll module. So let&#39;s invert the dependency and have each depend on the function signature. The signature of the function can act as a sort of &quot;contract&quot; between the two modules. Let&#39;s instead inject the save function when we want to run the PayCycle logic. This allows us to compose functions in new and interesting ways. defmodule PayCycle do def calculate_employee_pay(hours, employee_id, save_payroll_fn) do # ... complex calculation logic omitted save_payroll_fn.(employee_id, pay) end end defmodule Db.PayRoll do def save_payroll_to_database(employee_id, pay) do %PayRoll{ employee_id: employee_id, pay: calculated_value } |&gt; PayRoll.changeset() |&gt; Db.Repo end end With this principle applied to the code, we are ready to start using ExDoubles to create mocks."},{"ref":"readme.html#installation","title":"ExDoubles - Installation","type":"extras","doc":"This project is currently in it&#39;s prototype stage, but is available to test out. Once we feel confident in it&#39;s stability, we will do a proper Hex release. Until then, use at your own risk! def deps do [ {:exdoubles, git: &quot;https://github.com/steven-solomon/elephant&quot;, only: [:test]} ] end"}]